function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useState } from 'react';
import locale from "../../locale";
import MultipleCombo from "./../MultipleCombo";
import Utils from "./Utils";

var Custom = function Custom(_ref) {
  var value = _ref.value,
      ranges = _ref.ranges,
      type = _ref.type,
      min = _ref.min,
      max = _ref.max,
      onError = _ref.onError,
      onChange = _ref.onChange,
      _onVisibleChange = _ref.onVisibleChange;

  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      multipleDate = _useState2[0],
      setMultipleDate = _useState2[1];

  useEffect(function () {
    var _Utils$getDates = Utils.getDates(value),
        startDate = _Utils$getDates.startDate,
        endDate = _Utils$getDates.endDate;

    setMultipleDate([{
      type: type,
      id: 'start',
      name: locale('开始时间', 'start_time'),
      value: startDate
    }, {
      type: type,
      id: 'end',
      name: locale('结束时间', 'end_time'),
      value: endDate
    }]);
  }, [value]); // eslint-disable-line
  // 校验选择的区间是否合法

  function handleBeforeChange(newMultipleDate) {
    var newValue = [newMultipleDate[0].value, newMultipleDate[1].value];
    var timeValid = Utils.validateTime(newValue, {
      type: type,
      onError: onError
    });
    var daysValid = true;
    var daysLimit = Object.values(ranges)[0];

    if (typeof daysLimit === 'number') {
      daysValid = Utils.validateDays(newValue, {
        daysLimit: daysLimit,
        onError: onError
      });
    }

    return timeValid && daysValid;
  }

  function handleChange(newMultipleDate) {
    var newValue = [newMultipleDate[0].value, newMultipleDate[1].value];
    if (onChange) onChange(newValue);
  }

  if (toString.call(ranges) !== '[object Object]' || Object.isEmptyObject(ranges) || Object.keys(ranges).length !== 1 || // 未构建完成选中项也不渲染
  !multipleDate) {
    return null;
  }

  return /*#__PURE__*/React.createElement("div", {
    className: "datepicker-rangemodal-modal-card"
  }, /*#__PURE__*/React.createElement("p", {
    className: "datepicker-rangemodal-modal-card-caption"
  }, locale('自定义选择', 'custom_select')), /*#__PURE__*/React.createElement("div", {
    className: "datepicker-rangemodal-modal-card-buttons"
  }, Object.keys(ranges).map(function (rangeKey) {
    return /*#__PURE__*/React.createElement(MultipleCombo, {
      key: rangeKey,
      className: "datepicker-rangemodal-modal-card-button",
      value: multipleDate,
      type: type,
      min: min,
      max: max,
      onError: onError,
      onBeforeChange: handleBeforeChange,
      onChange: handleChange,
      ModalProps: {
        onVisibleChange: function onVisibleChange(visible) {
          // 显示弹窗, 需要隐藏父级弹窗
          if (visible) {
            _onVisibleChange(false);
          }
        }
      }
    }, rangeKey);
  })));
};

export default Custom;